<template>
    <div>
        <tr v-if="showValue(data, property)">
            <td class="w-25 font-weight-bold" v-if="value.type !== 'special'">{{ $t(`${value.label}`) }}:</td>
            
            <URIProp :property="property" :value="value" :data="data"><p>{{value.type}}</p></URIProp>
            <URLProp :property="property" :value="value" :data="data"></URLProp>
            <StringProp :property="property" :value="value" :data="data" :dpiLocale="dpiLocale"></StringProp>
            <ConditionalProp :property="property" :value="value" :data="data"></ConditionalProp>

            <!-- SPECIAL -->
            <div class="w-100" v-if="value.type === 'special'">
                <div v-for="(elem, index) in data[property]" :key="index">
                    <SpecialProp :property="property" :value="value" :data="elem" :dpiLocale="dpiLocale"></SpecialProp>
                </div>
            </div>
        </tr>
    </div>
</template>

<script>
import URIProp from './Properties/URIProp.vue';
import URLProp from './Properties/URLProp.vue';
import StringProp from './Properties/StringProp.vue';
import SpecialProp from './Properties/SpecialProp.vue';
import ConditionalProp from './Properties/ConditionalProp';

import { has, isNil, isEmpty } from 'lodash';

export default {
    components: {
        URIProp,
        URLProp,
        StringProp,
        SpecialProp,
        ConditionalProp,
    },
    props: {
        profile: String,
        data: Object,
        property: String,
        value: Object,
        dpiLocale: String,
        distId: Number,
    },
    methods: {
        showValue(property, value) {
            return has(property, value) && !isNil(property[value]) && !isEmpty(property[value]);
        },
    }
}
</script>